// DISCARD.CPP, old code that did something useful but ended up not being needed.

#define IMPORT_ASTYLE 0 /* the code was too poor quality */
//#include <iostream>
//#include <sstream>
#include <string>
#include "astyle/astyle.h"
//using namespace std;
//using namespace astyle;
// From astyle_main.cpp
class ASStreamIterator : public astyle::ASSourceIterator {
    public:
        ASStreamIterator(char *cin);
        virtual ~ASStreamIterator();
        bool hasMoreLines() const;
        string nextLine();
        char lastcrlf[3];
        unsigned lastcrlflen;

    private:
        char *inString;
};

ASStreamIterator::ASStreamIterator(char *in)    { inString = in; *lastcrlf='\0'; lastcrlflen=0;}
ASStreamIterator::~ASStreamIterator()           { /*delete inStream;*/}
bool ASStreamIterator::hasMoreLines() const     { return((*inString)?true:false);}

// This iterator produces a c-string a line at a time
string ASStreamIterator::nextLine() {
  int chn=strcspn(inString,"\r\n");
  char tempch=inString[chn];
  inString[chn]='\0';
  string str=string(inString);
  inString[chn]=tempch;
  inString+=chn;
  if (!*inString) lastcrlflen=0;
  else lastcrlflen=(*inString=='\r' && inString[1]=='\n')?2:1;
  if (lastcrlflen) memcpy(lastcrlf,inString,lastcrlflen);
  lastcrlf[lastcrlflen]='\0';
  inString+=lastcrlflen;
  return(str);
}

unsigned c_astyle(char *str,unsigned *strsln,unsigned *maxexpand,char **fail) {
  unsigned nv=0,sln;
  if (!fail || !*fail) {
    GetSLNValue("c_astyle")
    char *nstr; if (nstr=strdup(str)) {
      ::ASStreamIterator ite(nstr);
    
      //FormatterSettings settings;
      //settings.ApplyTo(formatter);
      
     *str='\0';
     if (maxexpand) {*maxexpand += sln; sln=0; }
#if 0
      while(ite.hasMoreLines()) {
        strcat(str,ite.nextLine().c_str());
        strcat(str,ite.lastcrlf);
      }
#else    
      astyle::ASFormatter formatter;
      formatter.setCStyle();
      formatter.init(&ite); 
      while (formatter.hasMoreLines()) {
        strcat(str,formatter.nextLine().c_str());
        strcat(str,ite.lastcrlf);
      }
#endif
      free(nstr);
      sln=strlen(str);
      if (strsln) *strsln = sln;
      if (maxexpand) *maxexpand -= sln;
      nv=1;
    }
  }
  return(nv);
}
#endif


// http://en.wikipedia.org/wiki/Binary_search
// array must be numeric only, continuous aka no sparseness, and sorted ascending
// returns key of found item or -1 if not found
// different bsearch algorithms are able to target the lowest or highest of a run of equals but we don't need that here
void *bsearchX(void *key,void *base,size_t nelem,size_t width,int (*fcmp)(const void *, const void *)) {
  void *targ;
#if 1
  size_t n;
  for(targ=base, n=0; n<nelem; (char *)targ+=width, n++) if (!fcmp(key,targ)) return(targ);
  return(NULL);
#else
  size_t left=0,right=nelem-1,midd;
  int dif;

  while (right-left>2) {
    midd = (left+right)/2;
    targ=(char *)base+midd*width;
    dif=fcmp(key,targ);
    if (dif<0) right=midd-1;
    else left=midd;
    //else if (dif>0) left=midd+1;
    //else return targ;
  }
  for(targ=(char *)base+left*width; left<=right; left++, (char *)targ+=width) if (!fcmp(key,targ)) return(targ);
  return NULL;
#endif
}

char *smprintf(size_t *size,const char *format,...) {
  char *rv;
  va_list ap;
  size_t len,vs;
  va_start(ap, format);
#if NPPDEBUG /* { */
  len=8;  /* initial buffer size */
#else /* } else { */
  len=1024;
#endif /* } */
  for(rv=(char *)malloc(len/*+100*/); len && rv && !(rv[len-1]='\0') && ((vs=vsnprintf(rv,len-1,format,ap))>len-1 || rv[len-1]); free(rv),rv=(char *)malloc(len)) {
#ifdef __WATCOMC__ /* { apparently you can't use the va_list over and over in Watcom-C */
  	va_end(ap);
  	va_start(ap, format);
  	vs++; /* when the buffer is too short, Watcom-C returns the entire required buffer length including the \0 byte, +1 from everyone else's library */
#endif /* } */
#if defined(__MINGW32__) || defined(_MSC_VER) || defined(__DMC__) /* {  bugged library returns -1 not enough buffer space */
  	if (vs == (unsigned)-1) len *=2; else
#endif /* } */
  	len=vs+1; /* if snprintf() ever returned -1 for any other reason, len would become 0 which would cause a halt */
#if NPPWINDOWS /* { no recursive calls please */
    //char debug[256]; snprintfX(debug,sizeof(debug),"vsnprintf() returns %u; Trying length %u",vs,len); MessageBox(nppData._nppHandle,debug,PLUGIN_NAME, MB_OK|MB_ICONSTOP);
#endif /* } */
  }
  va_end(ap);
#if NPPDEBUG /* { */
  if (vs != strlen(rv)) { /* no recursive calls please */
    char debug[256]; snprintfX(debug,sizeof(debug),"vs=%u strlen(rv)=%u",vs,strlen(rv)); MessageBox(nppData._nppHandle,debug,PLUGIN_NAME, MB_OK|MB_ICONSTOP);
    vs = strlen(rv);
  }
#endif /* } */
  if (rv && vs+1<len) {
    rv=(char *)realloc(rv,vs+1);
#if NPPWINDOWS /* { no recursive calls please */
    //char debug[256]; snprintfX(debug,sizeof(debug),"Final length (including \\0) was %u",vs+1); MessageBox(nppData._nppHandle,debug,PLUGIN_NAME, MB_OK|MB_ICONSTOP);
#endif /* } */
  }
  if (size) *size=rv?vs+1:0;
  //if (rv) puts(rv);
  return(rv);
}

#if 0 /* { nice code but so far always solved in another better way, also not rentrant */
static char *spc=NULL; // spc should be free() at the program end if not NULL
static unsigned spclen=0;
char *replicate(unsigned n,char ch) {
  if (!n || !ch) return("");
  if (spclen<n || !spc) {
    if (spc) freesafe(spc,"replicate");
    if (!(spc=(char *)mallocsafe(n+1,"replicate"))) {
      spclen=0;
      return("");
    }
    spc[0]='\0';
    spclen=n;
  }
  if (spc[0]!=ch) {
    memset(spc,ch,spclen);
    spc[spclen]='\0';
  }
  return(spc+spclen-n);
}
#endif /* } */

